<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.17.2.3.2.4 $
 * $Author: joergk $
 * $Date: 2009/05/22 20:55:22 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */
defined('mxMainFileLoaded') or die('access denied');

$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);

$pagetitle = _TOP10;

$top = (isset($_GET['top'])) ? intval($_GET['top']) : 10;
if (empty($top) || $top > 100) {
    $top = 10;
}

if ($GLOBALS["multilingual"] == 1) {
    if (strpos($GLOBALS['currentlang'], 'german') === 0) $thislang = "german";
    else $thislang = $GLOBALS["currentlang"];
    /* top stories */
    $queryalang = "WHERE (alanguage LIKE '$thislang%' OR alanguage='') AND `time` <= now()";
    /* top stories */
    $querya1lang = "WHERE (alanguage LIKE '$thislang%' OR alanguage='') AND";
    /* top section articles */
    $queryslang = "WHERE (slanguage LIKE '$thislang%' OR slanguage='') ";
    /* top polls */
    $queryplang = "WHERE (planguage LIKE '$thislang%' OR planguage='') ";
    /* top reviews */
    $queryrlang = "WHERE (rlanguage LIKE '$thislang%' OR rlanguage='') ";
} else {
    $queryalang = "WHERE `time` <= now()";
    $querya1lang = "WHERE";
    $queryslang = "";
    $queryplang = "";
    $queryrlang = "";
}

include('header.php');
title(_TOPWELCOME . ' ' . $sitename);
OpenTable();

/**
 * Top 10 read stories
 */
$result = sql_query("select sid, title, counter from ${prefix}_stories $queryalang AND counter>0 ORDER BY counter DESC LIMIT 0,$top");

$entry = array();
while (list($sid, $title, $counter) = sql_fetch_row($result)) {
    $entry[] = "<a href=\"modules.php?name=News&amp;file=article&amp;sid=$sid\">$title</a> - ($counter " . _READS . ')';
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _READSTORIES . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top 10 most voted stories
 */
$result = sql_query("select sid, title, ratings from ${prefix}_stories $querya1lang score>0 AND ratings>0 ORDER BY ratings DESC LIMIT 0,$top");

$entry = array();
while (list($sid, $title, $ratings) = sql_fetch_row($result)) {
    $entry[] = "<a href=\"modules.php?name=News&amp;file=article&amp;sid=$sid\">$title</a> - ($ratings " . _LVOTES . ')';
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _MOSTVOTEDSTORIES . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top 10 best rated stories
 */
$result = sql_query("SELECT `sid`, `title`, ROUND(score/ratings,2) as rate FROM `${prefix}_stories` $querya1lang score>0 AND ratings>=5 ORDER BY rate DESC, ratings DESC LIMIT 0,$top");

$entry = array();
while (list($sid, $title, $rate) = sql_fetch_row($result)) {
    $entry[] = "<a href=\"modules.php?name=News&amp;file=article&amp;sid=$sid\">$title</a> - ($rate " . _POINTS . ')';
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _BESTRATEDSTORIES . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top 10 commented stories
 */
$result = sql_query("select sid, title, comments from ${prefix}_stories $queryalang AND comments>0 ORDER BY comments DESC LIMIT 0,$top");

$entry = array();
while (list($sid, $title, $comments) = sql_fetch_row($result)) {
    $entry[] = "<a href=\"modules.php?name=News&amp;file=article&amp;sid=$sid\">$title</a> - ($comments " . _COMMENTS . ')';
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _COMMENTEDSTORIES . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top 10 categories
 */
$result = sql_query("select catid, title, counter from ${prefix}_stories_cat WHERE counter>0 ORDER BY counter DESC LIMIT 0,$top");

$entry = array();
while (list($catid, $title, $counter) = sql_fetch_row($result)) {
    $entry[] = "<a href=\"modules.php?name=News&amp;file=categories&amp;catid=$catid\">$title</a> - ($counter " . _HITS . ')';
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _ACTIVECAT . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top 10 articles in special sections
 */
$result = sql_query("select artid, secid, title, content, counter from " . $prefix . "_seccont $queryslang ORDER BY counter DESC LIMIT 0,$top");

$entry = array();
while (list($artid, $secid, $title, $content, $counter) = sql_fetch_row($result)) {
    if (trim($title)) {
        $entry[] = "<a href=\"modules.php?name=Sections&amp;artid=$artid\">$title</a> - ($counter " . _READS . ')';
    }
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _READSECTION . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top 10 users submitters
 */
$result = sql_query("select uname, counter from " . $user_prefix . "_users where counter>0 ORDER BY counter DESC LIMIT 0,$top");

$entry = array();
while (list($uname, $counter) = sql_fetch_row($result)) {
    if ($counter > 0) {
        $entry[] = mxCreateUserprofileLink($uname) . ' - (' . $counter . ' ' . _NEWSSENT . ')';
    }
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _NEWSSUBMITTERS . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top 10 Polls
 */
$result = sql_query("select * from " . $prefix . "_poll_desc $queryplang");

$entry = array();
$resultArray = array();
$result = sql_query("SELECT pollID, pollTitle, timeStamp, voters FROM " . $prefix . "_poll_desc $queryplang ORDER BY voters DESC LIMIT 0,$top");
$counter = 0;
while ($object = sql_fetch_array($result)) {
    $resultArray[$counter] = array($object['pollID'], $object['pollTitle'], $object['timeStamp'], $object['voters']);
    $counter++;
}
for ($count = 0; $count < count($resultArray); $count++) {
    $id = $resultArray[$count][0];
    $pollTitle = $resultArray[$count][1];
    $voters = $resultArray[$count][3];
    $sum = 0;
    for($i = 0; $i < 12; $i++) {
        $result = sql_query("SELECT optionCount FROM " . $prefix . "_poll_data WHERE (pollID=$id) AND (voteID=$i)");
        $object = sql_fetch_array($result);
        $optionCount = $object['optionCount'];
        $sum = (int)$sum + $optionCount;
    }
    $entry[] = "<a href=\"modules.php?name=Surveys&amp;pollID=$id\">$pollTitle</a> - ($sum " . _LVOTES . ')';
    $sum = 0;
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _VOTEDPOLLS . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top 10 authors
 */
$result = sql_query("select aid, counter from " . $prefix . "_authors WHERE counter>0 ORDER BY counter DESC LIMIT 0,$top");

$entry = array();
while (list($aid, $counter) = sql_fetch_row($result)) {
    if ($counter > 0) {
        $entry[] = "<a href=\"modules.php?name=Search&amp;query=&amp;author=" . urlencode($aid) . "\">$aid</a> - ($counter " . _NEWSPUBLISHED . ')';
    }
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _MOSTACTIVEAUTHORS . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top 10 downloads
 */
$result = sql_query("select lid, cid, title, hits from " . $prefix . "_downloads_downloads WHERE cid > 0 AND hits>0 ORDER BY hits DESC LIMIT 0,$top");

$entry = array();
while (list($lid, $cid, $title, $hits) = sql_fetch_row($result)) {
    if ($hits > 0) {
        $res = sql_query("select title from " . $prefix . "_downloads_categories where cid='" . intval($cid) . "'");
        list($ctitle) = sql_fetch_row($res);
        $utitle = str_replace(" ", "_", $title);
        $entry[] = "<a href=\"modules.php?name=Downloads&amp;op=view&amp;lid=" . $lid . "\">" . $title . "</a> (" . _CATEGORY . ": " . $ctitle . ") - (" . $hits . " " . _LDOWNLOADS . ')';
    }
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _DOWNLOADEDFILES . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top 10 weblinks
 */
$result = sql_query("select lid, cid, title, hits from " . $prefix . "_links_links WHERE hits>0 ORDER BY hits DESC LIMIT 0,$top");

$entry = array();
while (list($lid, $cid, $title, $hits) = sql_fetch_row($result)) {
    if ($hits > 0) {
        $res = sql_query("select title from " . $prefix . "_links_categories where cid='" . intval($cid) . "'");
        list($ctitle) = sql_fetch_row($res);
        $utitle = str_replace(" ", "_", $title);
        $entry[] = "<a href=\"modules.php?name=Web_Links&amp;op=view&amp;lid=$lid\">$title</a> (" . _CATEGORY . ": $ctitle) - ($hits " . _TIMESL . ')';
    }
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _LINKEDFILES . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top 10 Pages in Content
 */
$result = sql_query("select pid, title, counter from ${prefix}_pages where active='1' AND counter>0 ORDER BY counter DESC LIMIT 0,$top");

$entry = array();
while (list($pid, $title, $counter) = sql_fetch_row($result)) {
    $entry[] = "<a href=\"modules.php?name=Content&amp;pid=$pid\">$title</a> ($counter " . _READS . ')';
}
if (count($entry) > 1) {
    echo '<h3>' . count($entry) . ' ' . _MOSTREADPAGES . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
}

/**
 * Top xx Userpunkte
 */
if (!defined("mxYALoaded")) define("mxYALoaded", 1);
include(PMX_MODULES_DIR . DS . "Your_Account/config.php");
if (!empty($useuserpoints) || MX_IS_ADMIN) {
    // SQL-bedingung fuer excluded Users erstellen
    $exusers = explode (',', $excludedusers);
    if (!MX_IS_ADMIN) {
        foreach ($exusers as $key => $value) {
            $xexusers[] = trim($value);
        }
    }
    $xexusers[] = $GLOBALS['anonymous'];
    $xexusers[] = 'Anonymous';
    $excludedusers = "'" . implode("','", mxAddSlashesForSQL($xexusers)) . "'";

    $qry = "
        SELECT ${prefix}_userpoints.punkte, ${user_prefix}_users.uname
        FROM ${prefix}_userpoints
        LEFT JOIN ${user_prefix}_users
        ON ${prefix}_userpoints.uid = ${user_prefix}_users.uid
        WHERE ${user_prefix}_users.user_stat=1 AND ${prefix}_userpoints.punkte>0 AND (${user_prefix}_users.uname not in($excludedusers))
        ORDER BY ${prefix}_userpoints.punkte DESC, ${prefix}_userpoints.uid
        LIMIT 0, $top;";
    $result = sql_query($qry);

    $entry = array();
    while (list($punkte, $xuname) = sql_fetch_row($result)) {
        $entry[] = mxCreateUserprofileLink($xuname) . ' - (' . $punkte . ' ' . _USERPUNKTE1 . ')';
    }
    if (count($entry) > 1) {
        echo '<h3>' . count($entry) . ' ' . _TOPUSERPUNKTE . '</h3><ol><li>' . implode('</li><li>', $entry) . '</li></ol><br />';
    }
}
CloseTable();
include("footer.php");

?>